chiark / gitweb /
git-debrebase: breakwater_of: permit unclean to be an fproblem
[dgit.git] / tests / lib-build-modes
index cdf223d63e903eec1af8767e990cea32ba5ecb9a..ee2975d04c10a74cd53159aec53a0938e02548e0 100644 (file)
@@ -1,4 +1,17 @@
 
+bm-prep-ownpackage-branches () {
+       cat <<'END' >$tmp/stunt-git
+#!/bin/sh -e
+case "$*" in
+*clean*) echo >&2 "BUILD-MODES PROGRAM git $*" ;;
+esac
+exec git "$@"
+END
+       chmod +x $tmp/stunt-git
+
+       bm_branches="$1"
+}
+
 bm-prep () {
        t-tstunt-parsechangelog
 
@@ -11,14 +24,7 @@ bm-prep () {
                -i debian/control
        git commit -a -m bad-build-deps
 
-       cat <<'END' >$tmp/stunt-git
-#!/bin/sh -e
-case "$*" in
-*clean*) echo >&2 "BUILD-MODES PROGRAM git $*" ;;
-esac
-exec git "$@"
-END
-       chmod +x $tmp/stunt-git
+       bm-prep-ownpackage-branches 'indep-arch bad-build-deps'
 
        if zgrep 'dpkg-buildpackage: Make dependency checks fatal for -S' \
                /usr/share/doc/dpkg-dev/changelog.gz; then
@@ -32,31 +38,78 @@ END
        cleanmodes="$cleanmodes_default"
 }
 
+bm-gbp-example-acts () {
+       t-gbp-example-prep
+
+       git checkout -b for-build-modes qc/quilt-tip-2
+       # build-modes cannot cope with branches containing /
+
+       bm-prep-ownpackage-branches for-build-modes
+
+       cleanmodes='git dpkg-source'
+
+       for act in "$@"; do
+               bm-guess-e-source-e-targets "$act"
+               real_act="--quilt=gbp $act"
+               case "$act" in
+               sbuild*)    bm_quirk_after_act=bm-quirk-sbuild-after-act ;;
+               gbp-*)      real_act="$real_act --git-ignore-branch" ;;
+               *)          bm_quirk_after_act='' ;;
+               esac
+               bm-act-iterate
+       done
+}
+
 bm-guess-e-source-e-targets () {
        local some_act=$1
        case "$some_act" in
+       sbuild*" --no-arch-all"*)
+               e_source=true;  e_targets='build-arch binary-arch'      ;;
+       build-source)
+               e_source=true;  e_targets=''                            ;;
        *" -b") e_source=false; e_targets='build binary'                ;;
        *" -B") e_source=false; e_targets='build-arch binary-arch'      ;;
        *" -A") e_source=false; e_targets='build-indep binary-indep'    ;;
        *" -S") e_source=true;  e_targets=' '                           ;;
        *" -F") e_source=true;  e_targets='build binary'                ;;
+       *" -G") e_source=true;  e_targets='build-arch binary-arch'      ;;
+       *" -g") e_source=true;  e_targets='build-indep binary-indep'    ;;
        *)      e_source=true;  e_targets='build binary'                ;;
        esac
 }
 
+bm-quirk-sbuild-after-act () {
+       # sbuild likes to run the package clean target in the chroot,
+       # which isn't necessary in our case.  We don't disable it in
+       # dgit because we want to do what sbuild does, in case there
+       # are packages which don't build unless their clean target was
+       # run.  We know it must be running it in the chroot because we
+       # provide sbuild with the dsc, not the tree, so we simply
+       # ignore all executions of the clean target by schroot.
+       local arch; arch=$(dpkg-architecture -qDEB_BUILD_ARCH)
+       local sblog=../example_${v}_$arch.build
+       if [ -e $sblog ]; then
+               sed '
+                       s/^EXAMPLE RULES TARGET clean/HOOK SUPPRESSED &/;
+               ' <$sblog >>$bmlog
+       else
+               echo "SBUILD LOG FILE ($sblog) MISSING"
+       fi
+}
 
-bm-report-source () {
+bm-report-test () {
+       local desc=$1; shift
        if "$@"; then
-               echo >&4 "SOURCE EXISTS"
+               echo >&4 "$desc EXISTS"
        else
-               echo >&4 "SOURCE MISSING"
+               echo >&4 "$desc MISSING"
        fi
 }
 
 bm-build-deps-ok () {
        case "$branch" in
-       indep-arch)             return 0        ;;
-       bad-build-deps)         return 1        ;;
+       *bad-build-deps*)       return 1        ;;
+       *)                      return 0        ;;
        esac
 }
 
@@ -89,17 +142,21 @@ bm-compute-expected () {
                echo >&4 "EXAMPLE RULES TARGET $t"
        done
 
-       bm-report-source $e_source
+       bm-report-test "SOURCE FILE" $e_source
+       bm-report-test "SOURCE IN CHANGES" $e_source
+       bm-report-test "DEBS IN CHANGES" expr "$e_targets" : '.*binary.*'
 
        exec 4>&-
 }
 
 bm-run-one () {
-       local args="--clean=$cleanmode $real_act"
+       local args="$DGIT_TEST_BM_BASEARGS --clean=$cleanmode $real_act"
 
        bmid="$act,$cleanmode,$branch"
        bmid=${bmid// /_}
 
+       rm -f ../${p}_{v}_*.changes
+
        heading="===== [$bmid] dgit $args ====="
 
        bmlog=$tmp/run.$bmid.output
@@ -111,11 +168,11 @@ bm-run-one () {
        git checkout $branch
        git clean -xdf # since we might not do any actual cleaning
 
-       dsc='../example_1.0.dsc'
+       dsc="../example_$v.dsc"
        rm -f $dsc
 
        set +o pipefail
-       t-dgit --git=$tmp/stunt-git $args 2>&1 | tee $bmlog
+       t-dgit --rm-old-changes --git=$tmp/stunt-git $args 2>&1 | tee $bmlog
        local ps="${PIPESTATUS[*]}"
        set -o pipefail
 
@@ -139,7 +196,20 @@ bm-run-one () {
 
        egrep >&4 '^EXAMPLE RULES TARGET|^BUILD-MODES' $bmlog || [ $? = 1 ]
 
-       bm-report-source [ -e $dsc ]
+       bm-report-test "SOURCE FILE" [ -e $dsc ]
+
+       if [ $actual_status = success ]; then
+               local changes; changes=$(echo ../example_${v}_*.changes)
+               case "$changes" in
+               *' '*)  fail "build generated ambiguous .changes: $changes" ;;
+               esac
+
+               perl -ne 'print if m/^files:/i ... m/^\S/' \
+                       <$changes >$changes.files
+
+               bm-report-test "SOURCE IN CHANGES" grep '\.dsc$' $changes.files
+               bm-report-test "DEBS IN CHANGES" grep '\.deb$' $changes.files
+       fi
 
        exec 4>&-
 
@@ -150,9 +220,16 @@ bm-run-one () {
 
 bm-act-iterate () {
        for cleanmode in $cleanmodes; do
-               for branch in indep-arch bad-build-deps; do
+               for branch in $bm_branches; do
                        bm-run-one
                done
        done
        : bm-act-iterate done.
 }
+
+bm-alwayssplit () {
+       local t=${0##*/}
+       DGIT_TEST_BM_BASEARGS+=' --always-split-source-build'
+       export DGIT_TEST_BM_BASEARGS
+       t-chain-test "${t%%-asplit}"
+}